window.addEventListener('DOMContentLoaded', function() {
	//init drag & drop
	var handles = document.getElementsByClassName('translate-cell handle');
	var el_act = null;	//current drag elem
	var el_last = null;	//last element with a highlight border
	var i;
	for (i = 0; i < handles.length; i++) {
		var el = handles[i];
		el.setAttribute('draggable', 'true');

		el.addEventListener('mousedown', function (e) {
			starty = e.clientY;
		});

		el.addEventListener('dragstart', function (e) {
			e.dataTransfer.effectAllowed = 'copy';		// !
			e.dataTransfer.setData('Text', this.id);	// !
			el_act = this.parentNode;
			el_act.style.opacity = '0.5';
		});
		
		el.addEventListener('dragover', function (e) {
			if (e.preventDefault) e.preventDefault();
			e.dataTransfer.dropEffect = 'copy';			// !

			var el_this = this.parentNode;
			var el_next = this.parentNode.nextElementSibling;
			var rect = this.parentNode.getBoundingClientRect();
			var vcenter = (rect.top + rect.bottom) >> 1;

			if (el_last)
				el_last.className = 'translate-row';
			if (el_next) {
				if (e.clientY < vcenter) {
					el_last = el_this;
					el_this.className = 'translate-row over';
					el_next.className = 'translate-row';
				} else {
					el_last = el_next;
					el_next.className = 'translate-row over';
					el_this.className = 'translate-row';
				}
			} else {
				el_last = el_this;
			}
			return false;
		});

		el.addEventListener('drop', function (e) {
			if (e.stopPropagation) e.stopPropagation();
			if (e.preventDefault) e.preventDefault();
			el_act.style.opacity = '';
			
			var src = el_act;
			var dst = this.parentNode;
			var rect = dst.getBoundingClientRect();
			var vcenter = (rect.top + rect.bottom) / 2;
			if (e.clientY < vcenter)
				dst.parentNode.insertBefore(src, dst); //insert before
			else
				dst.parentNode.insertBefore(src, dst.nextSibling); //insert after
			if (el_last)
				el_last.className = 'translate-row';
		});
	}
});
